﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CsvUploader.Func
{
    public static class Extentions
    {
        public static Dictionary<string, string> ReplaceByRule(this Dictionary<string,string> source,IDictionary<string,string> convertPairs)
        {
            var tmp = source.ToList();
            foreach (var pair in tmp)
            {
                var name = pair.Key;
                //if (name.StartsWith("{") && name.EndsWith("}"))
                if (name.Contains("{") && name.Contains("}"))
                {
                    var startIndex = name.IndexOf("{");
                    var endIndex = name.IndexOf("}");
                    var replaceTarget = name.Substring(startIndex, endIndex - startIndex + 1);
                    var subName = replaceTarget.Substring(1, replaceTarget.Length - 2);

                    if (convertPairs.Keys.Contains(subName))
                    {
                        //var index = source.IndexOf(name);
                        //source.Remove(name);
                        source.Remove(name);

                        var tmpName = name.Replace(replaceTarget, convertPairs[subName].Trim(','));
                        //source.Insert(index, tmpName);
                        source.Add(tmpName, pair.Value);
                    }
                }
            }
            return source;
        }

        public static IEnumerable<string> ReplaceByRule(this IList<string> source, IDictionary<string, string> pairs)
        {
            var tmp = source.ToList();
            foreach (var name in tmp)
            {
                //if (name.StartsWith("{") && name.EndsWith("}"))
                if (name.Contains("{") && name.Contains("}"))
                {
                    var startIndex = name.IndexOf("{");
                    var endIndex = name.IndexOf("}");
                    var replaceTarget = name.Substring(startIndex, endIndex - startIndex + 1);
                    var subName = replaceTarget.Substring(1, replaceTarget.Length - 2);

                    if (pairs.Keys.Contains(subName))
                    {
                        var index = source.IndexOf(name);
                        source.Remove(name);

                        var tmpName = name.Replace(replaceTarget, pairs[subName].Trim(','));
                        source.Insert(index, tmpName);
                    }
                }
            }
            return source;
        }
    }
}
