﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CsvUploader.Model
{
    public class UploadTask
    {
        public string Name { get; set; }
        public string Folder { get; set; }
        public string FileNameRule { get; set; }
        public Dictionary<string, string> FilterByDataRules { get; set; }
        public string SqlConnectionString { get; set; }
        public string TableName { get; set; }
        public string TableNameRuleColumn { get; set; }
        public Dictionary<string, string> TableNameRules { get; set; }
        //public string IndexedColumnName { get; set; }
        //public List<string> CsvColumnNames { get; set; }
        //public List<string> DbColumnNames { get; set; }
        public List<CsvTable> Tables { get; set; }
        public Dictionary<string, string> CsvColNamesToDbColNames { get; set; }
        public Dictionary<string,string> StaticValues { get; set; }
        public List<string> PassToIntColumns { get; set; }
    }
}
